import { world, system, ItemStack, GameMode } from '@minecraft/server'

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.itemComponentRegistry.registerCustomComponent('v360:paint_brush', {
        onUseOn({ block, source: player, itemStack: selectedItem }) {
            const { x, y, z } = block.location
            if (block.getTags().includes('v360:brick') || block.typeId === 'minecraft:brick_block') {
                if (!player.matches({ gameMode: GameMode.creative })) {
                    const playerEquippableComp = player.getComponent('equippable')
                    const itemUsedDurabilityComp = selectedItem.getComponent('durability')
                    if (!itemUsedDurabilityComp) return;
                    system.run(function () {
                        const maxDurability = itemUsedDurabilityComp.maxDurability
                        const currentDamage = itemUsedDurabilityComp.damage
                        if (currentDamage >= maxDurability) {
                            system.run(() => {
                                playerEquippableComp.setEquipment('Mainhand', new ItemStack('v360:paint_brush', 1))
                            })
                        }
                        else if (currentDamage < maxDurability) {
                            system.run(() => {
                                itemUsedDurabilityComp.damage += 1;
                                playerEquippableComp.setEquipment('Mainhand', selectedItem)
                            })
                        }
                    })
                }
                if (selectedItem?.typeId === 'v360:paint_brush_with_black_dye') {
                    system.run(() => {
                        block.setType('v360:black_brick_block')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_blue_dye') {
                    system.run(() => {
                        block.setType('v360:blue_brick_block')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_brown_dye') {
                    system.run(() => {
                        block.setType('v360:brown_brick_block')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_cyan_dye') {
                    system.run(() => {
                        block.setType('v360:cyan_brick_block')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_green_dye') {
                    system.run(() => {
                        block.setType('v360:green_brick_block')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_gray_dye') {
                    system.run(() => {
                        block.setType('v360:gray_brick_block')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_light_blue_dye') {
                    system.run(() => {
                        block.setType('v360:light_blue_brick_block')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_light_gray_dye') {
                    system.run(() => {
                        block.setType('v360:light_gray_brick_block')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_lime_dye') {
                    system.run(() => {
                        block.setType('v360:lime_brick_block')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_magenta_dye') {
                    system.run(() => {
                        block.setType('v360:magenta_brick_block')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_orange_dye') {
                    system.run(() => {
                        block.setType('v360:orange_brick_block')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_pink_dye') {
                    system.run(() => {
                        block.setType('v360:pink_brick_block')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_purple_dye') {
                    system.run(() => {
                        block.setType('v360:purple_brick_block')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_red_dye') {
                    system.run(() => {
                        block.setType('v360:red_brick_block')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_white_dye') {
                    system.run(() => {
                        block.setType('v360:white_brick_block')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_yellow_dye') {
                    system.run(() => {
                        block.setType('v360:yellow_brick_block')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
            }
            if (block.getTags().includes('v360:mud_bricks') || block.typeId === 'minecraft:mud_bricks') {
                if (!player.matches({ gameMode: GameMode.creative })) {
                    const playerEquippableComp = player.getComponent('equippable')
                    const itemUsedDurabilityComp = selectedItem.getComponent('durability')
                    if (!itemUsedDurabilityComp) return;
                    system.run(function () {
                        const maxDurability = itemUsedDurabilityComp.maxDurability
                        const currentDamage = itemUsedDurabilityComp.damage
                        if (currentDamage >= maxDurability) {
                            system.run(() => {
                                playerEquippableComp.setEquipment('Mainhand', new ItemStack('v360:paint_brush', 1))
                            })
                        }
                        else if (currentDamage < maxDurability) {
                            system.run(() => {
                                itemUsedDurabilityComp.damage += 1;
                                playerEquippableComp.setEquipment('Mainhand', selectedItem)
                            })
                        }
                    })
                }
                if (selectedItem?.typeId === 'v360:paint_brush_with_black_dye') {
                    system.run(() => {
                        block.setType('v360:black_mud_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_blue_dye') {
                    system.run(() => {
                        block.setType('v360:blue_mud_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_brown_dye') {
                    system.run(() => {
                        block.setType('v360:brown_mud_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_cyan_dye') {
                    system.run(() => {
                        block.setType('v360:cyan_mud_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_green_dye') {
                    system.run(() => {
                        block.setType('v360:green_mud_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_gray_dye') {
                    system.run(() => {
                        block.setType('v360:gray_mud_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_light_blue_dye') {
                    system.run(() => {
                        block.setType('v360:light_blue_mud_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_light_gray_dye') {
                    system.run(() => {
                        block.setType('v360:light_gray_mud_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_lime_dye') {
                    system.run(() => {
                        block.setType('v360:lime_mud_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_magenta_dye') {
                    system.run(() => {
                        block.setType('v360:magenta_mud_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_orange_dye') {
                    system.run(() => {
                        block.setType('v360:orange_mud_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_pink_dye') {
                    system.run(() => {
                        block.setType('v360:pink_mud_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_purple_dye') {
                    system.run(() => {
                        block.setType('v360:purple_mud_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_red_dye') {
                    system.run(() => {
                        block.setType('v360:red_mud_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_white_dye') {
                    system.run(() => {
                        block.setType('v360:white_mud_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_yellow_dye') {
                    system.run(() => {
                        block.setType('v360:yellow_mud_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
            }
            if (block.getTags().includes('v360:stone_bricks') || block.typeId === 'minecraft:stone_bricks') {
                if (!player.matches({ gameMode: GameMode.creative })) {
                    const playerEquippableComp = player.getComponent('equippable')
                    const itemUsedDurabilityComp = selectedItem.getComponent('durability')
                    if (!itemUsedDurabilityComp) return;
                    system.run(function () {
                        const maxDurability = itemUsedDurabilityComp.maxDurability
                        const currentDamage = itemUsedDurabilityComp.damage
                        if (currentDamage >= maxDurability) {
                            system.run(() => {
                                playerEquippableComp.setEquipment('Mainhand', new ItemStack('v360:paint_brush', 1))
                            })
                        }
                        else if (currentDamage < maxDurability) {
                            system.run(() => {
                                itemUsedDurabilityComp.damage += 1;
                                playerEquippableComp.setEquipment('Mainhand', selectedItem)
                            })
                        }
                    })
                }
                if (selectedItem?.typeId === 'v360:paint_brush_with_black_dye') {
                    system.run(() => {
                        block.setType('v360:black_stone_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_blue_dye') {
                    system.run(() => {
                        block.setType('v360:blue_stone_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_brown_dye') {
                    system.run(() => {
                        block.setType('v360:brown_stone_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_cyan_dye') {
                    system.run(() => {
                        block.setType('v360:cyan_stone_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_green_dye') {
                    system.run(() => {
                        block.setType('v360:green_stone_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_gray_dye') {
                    system.run(() => {
                        block.setType('v360:gray_stone_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_light_blue_dye') {
                    system.run(() => {
                        block.setType('v360:light_blue_stone_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_light_gray_dye') {
                    system.run(() => {
                        block.setType('v360:light_gray_stone_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_lime_dye') {
                    system.run(() => {
                        block.setType('v360:lime_stone_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_magenta_dye') {
                    system.run(() => {
                        block.setType('v360:magenta_stone_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_orange_dye') {
                    system.run(() => {
                        block.setType('v360:orange_stone_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_pink_dye') {
                    system.run(() => {
                        block.setType('v360:pink_stone_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_purple_dye') {
                    system.run(() => {
                        block.setType('v360:purple_stone_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_red_dye') {
                    system.run(() => {
                        block.setType('v360:red_stone_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_white_dye') {
                    system.run(() => {
                        block.setType('v360:white_stone_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
                else if (selectedItem?.typeId === 'v360:paint_brush_with_yellow_dye') {
                    system.run(() => {
                        block.setType('v360:yellow_stone_bricks')
                        block.dimension.playSound('sign.dye.use', block.location)
                    })
                }
            }
        }
    })
})

world.beforeEvents.itemUseOn.subscribe(data => {
    const item = data.itemStack
    const block = data.block
    const player = data.source
    if (block.hasTag('v360:brick') && item?.typeId === 'minecraft:potion') {
        system.run(() => {
            block.setType('minecraft:brick_block')
            block.dimension.playSound('bottle.empty', block.location)
            player.runCommand(`replaceitem entity @s slot.weapon.mainhand 0 minecraft:glass_bottle 1`)
        })
    }
})

world.beforeEvents.itemUseOn.subscribe(data => {
    const item = data.itemStack
    const block = data.block
    const player = data.source
    if (block.hasTag('v360:mud_bricks') && item?.typeId === 'minecraft:potion') {
        system.run(() => {
            block.setType('minecraft:mud_bricks')
            block.dimension.playSound('bottle.empty', block.location)
            player.runCommand(`replaceitem entity @s slot.weapon.mainhand 0 minecraft:glass_bottle 1`)
        })
    }
})

world.beforeEvents.itemUseOn.subscribe(data => {
    const item = data.itemStack
    const block = data.block
    const player = data.source
    if (block.hasTag('v360:stone_bricks') && item?.typeId === 'minecraft:potion') {
        system.run(() => {
            block.setType('minecraft:stone_bricks')
            block.dimension.playSound('bottle.empty', block.location)
            player.runCommand(`replaceitem entity @s slot.weapon.mainhand 0 minecraft:glass_bottle 1`)
        })
    }
})

world.afterEvents.playerBreakBlock.subscribe(data => {
    const brokenBlock = data.brokenBlockPermutation
    const player = data.player
    const block = data.block
    const selectedItem = player.getComponent('equippable').getEquipment('Mainhand')
    const blockItem = data.dimension.getEntities({ type: 'minecraft:item', location: block.center(), maxDistance: 0.7 })
    if (player.getGameMode() !== 'creative') {
        if (brokenBlock.hasTag('minecraft:wood_tier_destructible') && brokenBlock.hasTag('minecraft:is_pickaxe_item_destructible') && (!selectedItem?.hasTag('minecraft:is_pickaxe'))) {
            blockItem[0].kill()
        }
    }
})